/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup TIM
  * @{
  */

/**
  * @addtogroup TIM_DMA
  * @{
  */

/* Private typedef --------------------------------------------------------------*/
TIM_InitTypeStruct TIM_InitStruct;
DMA_InitTypeStruct DMA_InitStruct;

/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/
static uint8_t buf_src[5] = {0x11, 0x22, 0x44, 0x88, 0xAA};
static uint8_t buf_dst[5] = {0};

/* Private functions ------------------------------------------------------------*/

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  uint32_t ledTime = 0;
  int8_t i = 0;
  /* Configure the system clock */
  SystemClockInit();
  /* Configure the system tick */
  SystickInit();

  /* LED Init */
  EVAL_LedInit(LED1);
  /* UART0 Init */
  EVAL_ComInit();

  /********************* Operation  *********************/
  printf("********************* Before  *********************\n");

  for(i = 0; i < 5; i++)
  {
    printf("buf_dst[%d] = %x \n", i, buf_dst[i]);
  }

  RCC_Unlock();
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_DMA, ENABLE);
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_TIM0, ENABLE);
  RCC_Lock();
  /* Config DMA */
  DMA_InitStruct.DMA_CICRState = DISABLE;
  DMA_InitStruct.DMA_DataNum = 1 - 1;
  DMA_InitStruct.DMA_DataSize = DMA_DATA_SIZE_8;
  DMA_InitStruct.DMA_DstAddr = (uint32_t)buf_dst;
  DMA_InitStruct.DMA_DstIncMode = DMA_ADDR_MODE_INCREASE;
  DMA_InitStruct.DMA_ErrIntState = DISABLE;
  DMA_InitStruct.DMA_FISIntState = DISABLE;
  DMA_InitStruct.DMA_ReqSource = DMA_TIM0_REQ;
  DMA_InitStruct.DMA_RoundNum = 5 - 1;
  DMA_InitStruct.DMA_SrcAddr = (uint32_t)buf_src;
  DMA_InitStruct.DMA_SrcIncMode = DMA_ADDR_MODE_INCREASE;
  DMA_Init(DMA_CH0, &DMA_InitStruct);
  DMA_Cmd(DMA_CH0, ENABLE);
  /* Config TIM0 */
  TIM_StructInit(&TIM_InitStruct);
  TIM_InitStruct.TIM_ReloadValue = 48000;
  TIM_InitStruct.TIM_CounterCycle = TIM_COUNTER_CYCLE_PERIOD;
  TIM_InitStruct.TIM_DMAState = ENABLE;
  TIM_InitStruct.TIM_IntState = DISABLE;
  TIM_Init(TIM0, &TIM_InitStruct);
  /* Enable TIM0-DMA */
  TIM_DMACmd(TIM0, ENABLE);
  /* Enable TIM0 */
  TIM_Cmd(TIM0, ENABLE);

  while(DMA_GetIntFlagStatus(DMA_CH0, DMA_INT_FLAG_FINISH) == RESET)
  {

  }

  printf("********************* After  *********************\n");

  for(i = 0; i < 5; i++)
  {
    printf("buf_dst[%d] = 0X%x \n", i, buf_dst[i]);
  }

  /* Infinite loop */
  while(1)
  {
    /* Runing led toggle */
    if(ledTime < GetTick())
    {
      ledTime = GetTick() + 1000;
      EVAL_LedToggle(LED1);
    }
  }
}

/**
  * @brief  This function is used to fputc.
  * @param  None
  * @retval None
  */
int fputc(int ch, FILE *f)
{
  while(UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE) == RESET);

  UART_SendData(EVAL_COM0, ch) ;
  return ch;
}


/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
